/*****************************************************
 *$B!!(BPIC16F18xx$B%U%!%_%j$N;HMQNc(B
 *  18$B%S%C%H%G%k%?%7%0%^(BA/D$B$r;H$C$?EE057W(B
 *  I2C$B%$%s%?!<%U%'!<%9$G(BADC$B$H(BLCD$B$r@\B3(B
 *$B!!%U%!%$%kL>!'(BSmallMeter.c
******************************************************/
#include  <htc.h>
#include  "lcd_lib2.h"
#include  "i2c_lib2.h"

/***** $B%3%s%U%#%.%e%l!<%7%g%s@_Dj(B *********/
__CONFIG(FOSC_INTOSC & WDTE_OFF & PWRTE_ON & MCLRE_ON & CP_OFF
	& CPD_OFF & BOREN_ON & CLKOUTEN_ON & IESO_OFF & FCMEN_OFF);
__CONFIG(WRT_OFF & PLLEN_OFF & STVREN_OFF & LVP_OFF);

/* $B4X?t$N%W%m%H%?%$%T%s%0(B */
void ltostring(char digit, unsigned long data, char *buffer);
void Display(void);

/* $B%0%m!<%P%kJQ?t!!(B*/
unsigned char State, Gain, Result[5];
unsigned int BatV;
unsigned long Value;
/* $BI=<(MQ%G!<%?(B */
const unsigned char Vhead1[] = "High Range <2.0V";
const unsigned char Vhead8[] = "Low  Range <0.2V";
const unsigned char Vmsg[]   = "Volt= +xxxx.x mV";
unsigned char DataMsg[] 	= "+xx.xxx";

/******** $B%a%$%s4X?t(B  ************/
void main(void){
    /** Set Clock ***/
    OSCCON = 0x68;				// Set to 4MHz
    /** Set I/O Port ***/
    LATA = 0x06;				// AN1,2 default High
    TRISA = 0x0E;                               // AN1,2 $BF~NO@_Dj(B
    ANSELA = 0;                                 // $BA4%G%8%?%k$K@_Dj(B
    /** I2C$B=i4|2=(B **/
    SSP1ADD = 0x09;                             // 100kHz@32MHz
    SSP1CON1 = 0x38;                            // I2C$B%$%M!<%V%k(B
    SSP1STAT = 0;                               // $B>uBV%/%j%"(B
    /** LCD$B=i4|2=(B **/
    lcd_init();					// $B1U>=I=<(4o$N=i4|2=(B
    lcd_str("Start");
    /************ $B%a%$%s%k!<%W(B  **********/
    while(1)    {
        lcd_icon(2, 1);                         // $B7WB,CfL\0u%*%s(B
        /** $B7WB,<B9T(B **/
        switch(State){				// $B%9%F!<%H$G?J$a$k(B
            case 0:				// $B=i4|>uBV$N>l9g(B
                SendI2C(0xD0, 0x8C);		// ADC$B=i4|2=(B Gain=1 18$B%S%C%H(B
                State = 1;			// $B%9%F!<%H<!$X(B
                break;
            case 1:				// $B%3%^%s%IAw?.8e$N>l9g(B
                GetDataI2C(0xD0, Result, 3);    // $B%G!<%?<hF@(B 3$B%P%$%H(B
                if(Gain)                        // $B%2%$%s$N@Z$jBX$((B
                    SendI2C(0xD0, 0x8F);	// 18bit Gain x8 Start
                else
                    SendI2C(0xD0, 0x8C);	// 18bit Gain x1 Start
                State = 2;			// $B%9%F!<%H<!$X(B
                break;
            case 2:				// $BF~NO40N;BT$A$N>l9g(B
                Display();			// $BB,DjCMJQ49I=<((B
                lcd_icon(2, 0);                 // $B7WB,CfL\0u%*%U(B
                State = 1;			// $B%9%F!<%H$rLa$9(B                
                break;
            default: break;
        }
        delay_100ms(3);				// $BB,Dj4V3VMQCY1d(B
    }
}
/***************************************
*  $BB,DjCM$r49;;$7I=<((B
***************************************/
void Display(void){
    /* $BJQ49F~NOCM$r?tCM$KJQ49!!(B*/
    if((Result[0] & 0x02) == 0){                // $B@5$NCM$N>l9g(B
        Value = ((long)(Result[0]&0x01)<<16)+
        ((long)Result[1]<<8)+((long)Result[2]);
        DataMsg[0] = '+';
    }
    else{                                       // $BIi$NCM$N>l9g(B
        Result[0] = ~Result[0] & 0x01;          // 0,1$BH?E>(B
        Result[1] = ~Result[1];                 // 0,1$BH?E>(B
        Result[2] = ~Result[2];
        Value = ((long)Result[0]<<16)+
        ((long)Result[1]<<8)+((long)Result[2])+1;
        DataMsg[0] = '-';
    }
    /* $BEE05$NB,DjCM$X$NJQ49$HI=<(!!(B*/
    if(!Gain){
        /* $B%2%$%s(B1$BG\$N>l9g!!!J(BHigh Range) */
        Value = (20480*Value)/0x1FFFF;          // mV$B$KJQ49(B
        if(Value < 2000)                        // $BCM$,>.$5$$$+!)(B
            Gain = 1;                           // Low Range$B$X(B
        if(Value > 20470){                      // $B%U%k%9%1!<%k%*!<%P!<$+!)(B
            DataMsg[0] = 'O';
            DataMsg[1] = 'v';
            DataMsg[2] = 'e';                   // Over$B%a%C%;!<%8(B
            DataMsg[3] = 'r';
            DataMsg[4] = '!';
            DataMsg[5] = '!';
            DataMsg[6] = ' ';
        }
        else{                                   // $B@5>oHO0O$N>l9g(B
            ltostring(5, Value, DataMsg+1);     // $BJ8;z$KJQ49(B
            DataMsg[6] = DataMsg[5];            // $B>.?tIt1&0\F0(B
            DataMsg[5] = '.';                   // $B>.?tE@DI2C!!(B1234.5
        }
    }
    else{
        /* $B%2%$%s(B8$BG\$N>l9g(B  $B!J(BLow Range) */
        Value = (25600*Value)/0x1FFFF;          // mV$B$KJQ49(B
        if(Value > 25000){                      // $B%U%k%9%1!<%k%*!<%P!<$+!)(B
            Gain = 0;                           // High Range$B$X(B
            DataMsg[0] = 'O';
            DataMsg[1] = 'v';
            DataMsg[2] = 'e';                   // $B%*!<%P!<%a%C%;!<%8(B
            DataMsg[3] = 'r';
            DataMsg[4] = '!';
            DataMsg[5] = '!';
            DataMsg[6] = ' ';
        }
        else{                                   // $B@5>oHO0O$N>l9g(B
            ltostring(5, Value, DataMsg+1);     // $BJ8;z$KJQ49(B
            DataMsg[6] = DataMsg[5];            // $B>.?tIt1&0\F0(B
            DataMsg[5] = DataMsg[4];            // 123.45
            DataMsg[4] = '.';                   // $B>.?tE@DI2C(B
        }
    }
    /* $BEE05I=<(<B9T(B */
    lcd_cmd(0x80);                              // 1$B9TL\;XDj(B
    if(!Gain)                                   // $B%l%s%8%A%'%C%/(B
        lcd_str(Vhead1);                        // High Range
    else
        lcd_str(Vhead8);                        // Low Range
    lcd_cmd(0xC0);                              // 2$B9TL\@hF,;XDj(B
    lcd_str(Vmsg);                              // $B8GDj%a%C%;!<%8I=<((B
    lcd_cmd(0xC6);                              // $B?tCM0LCV$X0\F0(B
    lcd_str(DataMsg);                           // $BB,DjCMIt99?7(B
 }
/***************************************
* $B@0?t$+$i(BASCII$BJ8;z$KJQ49(B
****************************************/
void ltostring(unsigned char digit, unsigned long data, unsigned char *buffer){
	unsigned char i;

	buffer += digit;			// $B:G8e$N?t;z0LCV(B
	for(i=digit; i>0; i--) {		// $BJQ49$O2<0L$+$i>e0L$X(B
		buffer--;			// $B%]%$%s%?!<#1(B
		*buffer = (data % 10) + '0';	// ASCII$B$X(B
		data = data / 10;		// $B<!$N7e$X(B
	}
}



